# simple illustration client/server pair; client program sends a string
# to server, which echoes it back to the client (in multiple copies),
# and the latter prints to the screen
# this is the server

import socket
import sys
import objc
import time
from AppKit import NSScreen

width, height = int(NSScreen.mainScreen().frame().size.width), int(NSScreen.mainScreen().frame().size.height)

class ETMouse():
	def setMousePosition(self, x, y):
		bndl = objc.loadBundle('CoreGraphics', globals(), '/System/Library/Frameworks/ApplicationServices.framework')
		objc.loadBundleFunctions(bndl, globals(), [('CGWarpMouseCursorPosition', 'v{CGPoint=ff}')])
		CGWarpMouseCursorPosition((x, y))

# create a socket
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
# associate the socket with a port
host = '' # can leave this blank on the server side
port = int(sys.argv[1])
s.bind((host, port))

# accept "call" from client
s.listen(1)
conn, addr = s.accept()
print 'client is at', addr

# read string from client (assumed here to be so short that one call to
# recv() is enough), and make multiple copies (to show the need for the
# "while" loop on the client side)

et = ETMouse()
l3x = [width/2, width/2, width/2]
l3y = [height/2, height/2, height/2]

def average(a):
	b = len(a)
	c = 0
	for i in a:
		c = c+i
	return c/b

for i in range (1000):
	data = conn.recv(1024)
	print data
	[x, y, z] = eval(data.split("\n")[-2])
	l3x = l3x[1:]
	l3y = l3y[1:]
	l3x.append(int(x))
	l3y.append(int(y))
	
	#smooth inputs by averaging last 3 readings
	x = average(l3x)
	y = average (l3y)
	et.setMousePosition((y/1400.0+0.5)*width, (x/1400.0+0.5)*height)
	time.sleep(0.1)
	

# close the conn
conn.close()